// Generated by ParserBuilder @ 27/05/2001 4:51:15 PM

unit Win32OnlyParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder - unless you run the Delphi Import command*)


interface

uses
  Windows, Messages, SysUtils, Classes,Win32OnlyScanner;


const
  maxT = 9;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div  setsize] of BITSET;

{PBGLOBAL}

{ENDPBGLOBAL}




type
  TWin32OnlyParser = class(TWin32OnlyScanner)
  private
    FSuccessful: boolean;
    {PBPRIVATE}
    fOutputStream : TStringStream;
 fCollectStart : Integer;
 fCollectLength : Integer;
 procedure Init;
 procedure Final;
 Function CalcLength : Integer;
 procedure SetStart;
 function CopySourceToCurrent : String;
 procedure WriteStr(S : string);
 Function GetLexString : String;
 procedure ReportError(nr, line, col, pos: integer);

    {ENDPBPRIVATE}
    procedure PerformGet;
    procedure SynError(errNo: integer);
    procedure SemError(errNo: integer);
    function _In(var s: TSymbolSet; x: integer): boolean;
    procedure Expect(n: integer);
    procedure ExpectWeak(n, follow: integer);
    function WeakSeparator(n, syFol, repFol: integer): boolean;
    function GetSuccessful: boolean;
    Procedure SetSourceString(const Value : String);
        Procedure _LINUX;
    Procedure _Win32Only;


  protected
    {PBPROTECTED}
     
    {ENDPBPROTECTED}
  public
    {PBPUBLIC}
    
    {ENDPBPUBLIC}
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    Property SourceString : String write SetSourceString;
    {PBPUBLISHED}
    
    {ENDPBPUBLISHED}
  end;

implementation

var
  symSet: array [0..0] of TSymbolSet;
  errDist: integer;
  sym: integer;

{  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
   + For ParserBuilder's Delphi import function to work,        -
   + you must place your code in this Arbitrary Source section. -
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- }

{PBARBITRARYSOURCE}


Procedure TWin32OnlyParser.SetStart;
Begin
 fCollectStart := nextPos+1;
End;

procedure TWin32OnlyParser.Init;
begin
 fOutputStream.Size := 0;
 fCollectStart := 0;
 fCollectLength := 0;
 lst.Size := 0;
end;

Function TWin32OnlyParser.CopySourceToCurrent : String;
Begin
 CalcLength;
 Result := Copy(src.DataString, FCollectStart, fCollectLength);
End;

Function TWin32OnlyParser.CalcLength : Integer;
Begin
 Result := nextPos - fCollectStart+1;
 fCollectLength := Result;
End;

procedure TWin32OnlyParser.Final;
begin
 if Errors>0 then
  lst.WriteString('*** Errors ***' );
 lst.WriteString(fOutputStream.DataString);
 fOutputStream.Size := 0;
end;

procedure TWin32OnlyParser.WriteStr(S : string);
begin
 fOutputStream.WriteBuffer(S[1],length(S));
end;

Function TWin32OnlyParser.GetLexString : String;
Begin
 LexString(Result);
end;

procedure TWin32OnlyParser.ReportError(nr, line, col, pos: integer);
Var
 S, S1 : String;
 SL : TStringList;
begin
 Case nr of
 {$I  Win32Only.err}
 End; // Case
 S := CRLF +S+CRLF + 'Line ' +IntToStr(line)+CRLF+'Column ' +
   IntToStr(col)+CRLF+'................................' +CRLF;
 SL := TStringList.Create;
 SL.Text := src.DataString;
 if Line<SL.Count then
   S1 := SL[Line-1]
  else S1 := '[End Of Source File]' ;
 SL.Free;
 Insert(' ERROR->' ,S1,Col-1);
 Inc(fErrors);
 WriteStr(S+S1+CRLF);
end;




{ENDPBARBITRARYSOURCE}

 { TWin32OnlyParser - Generated Methods below}
procedure TWin32OnlyParser.SemError(errNo: integer);
begin
  if errDist >= minErrDist then
  begin
     Error(errNo, line, col, pos);
  end;
  errDist := 0;
end;

procedure TWin32OnlyParser.SynError(errNo: integer);
begin
  if errDist >= minErrDist then
  begin
     Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TWin32OnlyParser.PerformGet;
var
  s: string;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin
     
    end;
  until sym <= maxT
  end;

function TWin32OnlyParser._In(var s: TSymbolSet; x: integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TWin32OnlyParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TWin32OnlyParser.Expect(n: integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

procedure TWin32OnlyParser.ExpectWeak(n, follow: integer);
begin
  if Sym = n then PerformGet
  else
  begin
    SynError(n);
    while not _In(symSet[follow], Sym) do PerformGet;
  end
end;

function TWin32OnlyParser.WeakSeparator(n, syFol, repFol: integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TWin32OnlyParser.LexName(var Lex: string);
begin
    GetName(pos, len, Lex)
end;

procedure TWin32OnlyParser.LexString(var Lex: string);
begin
   GetString(pos, len, Lex)
end;

procedure TWin32OnlyParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TWin32OnlyParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

Procedure TWin32OnlyParser.SetSourceString(const Value : String);
Begin
  if (src<> NIL) then
    src.Free;
  src := TStringStream.Create(Value);
End;

Procedure TWin32OnlyParser._LINUX;
  BEGIN
    Expect(4);
    IF (sym = 5) THEN BEGIN
      WriteStr( ' (*  {$IFDEF LINUX}  *) ' ) ;
      PerformGet;
      WriteStr( '(* ' ) ;
      SetStart ;
      WHILE (sym < 16) (* prevent range error *) AND
            (sym IN [1, 2, 3, 4, 5, 8, 9])  DO BEGIN
        PerformGet;
      END;
      WriteStr( CopySourceToCurrent ) ;
      WriteStr( ' *) ' ) ;
      IF (sym = 6) THEN BEGIN
        WriteStr( '(* ' ) ;
        PerformGet;
        WriteStr( ' *) ' ) ;
        SetStart ;
        WHILE (sym < 16) (* prevent range error *) AND
              (sym IN [1, 2, 3, 4, 5, 6, 8, 9])  DO BEGIN
          PerformGet;
        END;
        WriteStr( CopySourceToCurrent ) ;
      END;
      WriteStr( '(* ' ) ;
      Expect(7);
      WriteStr( ' {$ENDIF}  *) ' ) ;
    END ELSE IF (sym = 1) THEN BEGIN
      SetStart ;
      PerformGet;
      Expect(8);
      WriteStr( ' {$IFDEF ' +CopySourceToCurrent  ) ;
    END ELSE BEGIN SynError(10);
    END;
  END;

Procedure TWin32OnlyParser._Win32Only;
  BEGIN
    Init ;
    WHILE (sym < 16) (* prevent range error *) AND
          (sym IN [1, 2, 3, 4, 5, 6, 7, 8, 9])  DO BEGIN
      IF (sym < 16) (* prevent range error *) AND
         (sym IN [1, 2, 3, 5, 6, 7, 8, 9])  THEN BEGIN
        SetStart ;
        PerformGet;
        WriteStr( CopySourceToCurrent ) ;
      END ELSE BEGIN
        _LINUX;
      END;
    END;
    Expect(0);
    Final ;
  END;



procedure TWin32OnlyParser.Parse;
begin
  if (src.DataString = '') then 
    lst.WriteString('Empty Source')
    Else Begin    
   _Reset; PerformGet;
   _Win32Only;

    End;
end;

destructor TWin32OnlyParser.Destroy;
Begin
{PBDESTROY}
  fOutputStream.Free;

{ENDPBDESTROY}
  inherited;
End;

constructor TWin32OnlyParser.Create;
begin
  inherited;
{PBCREATE}
  fOutputStream := TStringStream.Create('' );
 Error := ReportError;

{ENDPBCREATE}
  errDist := minErrDist;
   symSet[0, 0] := [0];
end;


end.   (* Win32OnlyParser *)
