// Generated by ParserBuilder @ 24/04/2002 12:27:53 PM

unit pbCocoParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder - unless you run the Delphi Import command*)


interface

uses
  Windows, Messages, SysUtils, Classes, pbCocoTable, pbCocoAutomaton,
  pbCocoSets, pbCocoConstants, CocoGUITable, pbCocoScanner,
  pbCocoG (* Symbol Constants *);


const
  maxT = 58;
  maxP = 59;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div setsize] of BITSET;

  {PBGLOBAL}

  {ENDPBGLOBAL}




type
  TpbCocoParser = class(TpbCocoScanner)
  private
    FSuccessful: boolean;
    {PBPRIVATE}
    FCocoTable: TpbCocoTable;
    FCocoAutomaton: TpbCocoAutomaton;
    //    fCollector: string;
    fHasOptions: boolean;
    procedure FixString(var Name: string; len: Integer);
    procedure MatchLiteral(sp: Integer);
    procedure SetCocoAutomaton(const Value: TpbCocoAutomaton);
    procedure SetCtx(gp: Integer);
    //    procedure ResetCollector;
    //    procedure CollectLex;
    //    function GetLexString: string;
    procedure SetOption(s: string);
    procedure SetCocoTable(const Value: TpbCocoTable);

    {ENDPBPRIVATE}
    procedure PerformGet;
    procedure SynError(errNo: Integer);
    procedure SemError(errNo: Integer);
    function _In(var s: TSymbolSet; x: Integer): boolean;
    procedure Expect(n: Integer);
    procedure ExpectWeak(n, follow: Integer);
    function WeakSeparator(n, syFol, repFol: Integer): boolean;
    function GetSuccessful: boolean;
    procedure SetSourceString(const Value: string);
    procedure _TokenFactor(var gL, gR: Integer);
    procedure _TokenTerm(var gL, gR: Integer);
    procedure _Factor(var gL, gR: Integer);
    procedure _Term(var gL, gR: Integer);
    procedure _Symbol(var Name: TsName; var kind: Integer);
    procedure _SingleChar(var n: Integer);
    procedure _SimSet(var oneSet: TCRTSet);
    procedure _Set(var oneSet: TCRTSet);
    procedure _TokenExpr(var gL, gR: Integer);
    procedure _NameDecl;
    procedure _TokenDecl(typ: TCocoNodeType);
    procedure _SetDecl;
    procedure _Expression(var gL, gR: Integer);
    procedure _SemText(var semPos: TPosition);
    procedure _Attribs(var attrPos: TPosition);
    procedure _Declaration(var startedDFA: boolean);
    procedure _ClassSection;
    procedure _Ident(var Name: TsName);
    procedure _pbCoco;


  protected
    {PBPROTECTED}
     
    {ENDPBPROTECTED}
  public
    {PBPUBLIC}
    
    {ENDPBPUBLIC}
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    property SourceString: string write SetSourceString;
    {PBPUBLISHED}
    property CocoTable: TpbCocoTable read FCocoTable write SetCocoTable;
    property CocoAutomaton: TpbCocoAutomaton read FCocoAutomaton write SetCocoAutomaton;

    {ENDPBPUBLISHED}
  end;

implementation

var
  symSet: array [0..18] of TSymbolSet;
  errDist: integer;
  sym: integer;

{  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
   + For ParserBuilder's Delphi import function to work,        -
   + you must place your code in this Arbitrary Source section. -
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- }

  {PBARBITRARYSOURCE}


const
  ident = 1;
  stringSym = 2;

procedure TpbCocoParser.SetCocoTable(const Value: TpbCocoTable);
begin
  FCocoTable := Value;
end;

//function TpbCocoParser.GetLexString: string;
//begin
//  LexString(Result);
//end;

//procedure TpbCocoParser.ResetCollector;
//begin
//  fCollector := '';
//end;

//procedure TpbCocoParser.CollectLex;
//begin
//  fCollector := fCollector + GetLexString;
//end;

procedure TpbCocoParser.SetCocoAutomaton(const Value: TpbCocoAutomaton);
begin
  FCocoAutomaton := Value;
end;

procedure TpbCocoParser.FixString(var Name: string; len: Integer);
var
  double, spaces: boolean;
  i: integer;
begin
  if len = 2 then
  begin
    SemError(129);
    EXIT
  end;
  if CocoTable.ignoreCase then
    for i := 2 to len - 1 do Name[i] := UpCase(Name[i]);
  double := False;
  spaces := False;
  for i := 2 to len - 1 do
  begin
    if Name[i] = '"' then double := True;
    if Name[i] <= ' ' then spaces := True;
  end;
  if not double then
  begin
    Name[1] := '"';
    Name[len] := '"'
  end;
  if spaces then SemError(124);
end;

procedure TpbCocoParser.MatchLiteral(sp: Integer);
var
  sn, sn1: TSymbolNode;
  matchedSp: integer;
begin
  CocoTable.GetSym(sp, sn);
  CocoAutomaton.MatchDFA(sn.Name, sp, matchedSp);
  if matchedSp <> Ord(cnNoSym) then
  begin
    CocoTable.GetSym(matchedSp, sn1);
    sn1.struct := classLitToken;
    CocoTable.PutSym(matchedSp, sn1);
    sn.struct := litToken
  end
  else
    sn.struct := classToken;
  CocoTable.PutSym(sp, sn)
end;

procedure TpbCocoParser.SetCtx(gp: Integer);
var
  gn: TGraphNode;
begin
  while gp > 0 do
  begin
    CocoTable.GetNode(gp, gn);
    if (gn.gnType = cnSingleChar) or (gn.gnType = cnCharClass) then
    begin
      gn.p2 := contextTrans;
      CocoTable.PutNode(gp, gn)
    end
    else if (gn.gnType = cnOption) or (gn.gnType = cnIteration) then SetCtx(gn.p1)
    else if gn.gnType = cnAlternative then
    begin
      SetCtx(gn.p1);
      SetCtx(gn.p2)
    end;
    gp := gn.Next
  end
end;

procedure TpbCocoParser.SetOption(s: string);
var
  i: integer;
begin
  for i := 1 to Length(s) do
  begin
    s[i] := UpCase(s[i]);
    if s[i] in ['A'..'Z'] then CocoTable.ddt[s[i]] := True;
  end;
end;




{ENDPBARBITRARYSOURCE}

 { TpbCocoParser - Generated Methods below}
procedure TpbCocoParser.SemError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, line, col, pos);
  end;
  errDist := 0;
end;

procedure TpbCocoParser.SynError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TpbCocoParser.PerformGet;
var
  s: string;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin
      case sym of
        OptionsSym: 
        begin 
          if not fHasOptions then
          begin
            GetName(nextPos, nextLen, s);
            SetOption(s);
          end;
          fHasOptions := True; 
        end;
      end;
      nextPos := pos;
      nextCol := col;
      nextLine := line;
      nextLen := len;
    end;
  until sym <= maxT
  end;

function TpbCocoParser._In(var s: TSymbolSet; x: Integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TpbCocoParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TpbCocoParser.Expect(n: Integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

procedure TpbCocoParser.ExpectWeak(n, follow: Integer);
begin
  if Sym = n then PerformGet
  else
  begin
    SynError(n);
    while not _In(symSet[follow], Sym) do PerformGet;
  end
end;

function TpbCocoParser.WeakSeparator(n, syFol, repFol: Integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TpbCocoParser.LexName(var Lex: string);
begin
  GetName(pos, len, Lex)
end;

procedure TpbCocoParser.LexString(var Lex: string);
begin
  GetString(pos, len, Lex)
end;

procedure TpbCocoParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TpbCocoParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

procedure TpbCocoParser.SetSourceString(const Value: string);
begin
  if (src <> nil) then
    src.Free;
  src := TStringStream.Create(Value);
end;

procedure TpbCocoParser._TokenFactor(var gL, gR: Integer);
var
  kind, C: integer;
  oneSet: TCRTSet;
  Name: TsName;
begin
  gL := 0;
  gR := 0;
  if (sym = identSym) or
    (sym = stringSym) then 
  begin
    _Symbol(Name, kind);
    if Ord(kind) = ident then
    begin
      c := CocoTable.ClassWithName(Name);
      if c < 0 then 
      begin
        SemError(115);
        Clear(oneSet);
        c := CocoTable.NewClass(Name, oneSet)
      end;
      gL := CocoTable.NewNode(cnCharClass, c, 0);
      gR := gL;
    end
    else
      CocoTable.StrToGraph(Name, gL, gR);
  end 
  else if (sym = _lparenSym) then 
  begin
    PerformGet;
    _TokenExpr(gL, gR);
    Expect(_rparenSym);
  end 
  else if (sym = _lbrackSym) then 
  begin
    PerformGet;
    _TokenExpr(gL, gR);
    Expect(_rbrackSym);
    CocoTable.MakeOption(gL, gR);
  end 
  else if (sym = _lbraceSym) then 
  begin
    PerformGet;
    _TokenExpr(gL, gR);
    Expect(_rbraceSym);
    CocoTable.MakeIteration(gL, gR);
  end 
  else 
  begin 
    SynError(59);
  end;
end;

procedure TpbCocoParser._TokenTerm(var gL, gR: Integer);
var
  gL2, gR2: integer;
begin
  _TokenFactor(gL, gR);
  while (sym = identSym) or
    (sym = stringSym) or
    (sym = _lparenSym) or
    (sym = _lbrackSym) or
    (sym = _lbraceSym) do 
  begin
    _TokenFactor(gL2, gR2);
    CocoTable.ConcatSeq(gL, gR, gL2, gR2);
  end;
  if (sym = CONTEXTSym) then 
  begin
    PerformGet;
    Expect(_lparenSym);
    _TokenExpr(gL2, gR2);
    SetCtx(gL2);
    CocoTable.ConcatSeq(gL, gR, gL2, gR2);
    Expect(_rparenSym);
  end;
end;

procedure TpbCocoParser._Factor(var gL, gR: Integer);
var
  sp, kind: integer;
  Name: TsName;
  gn: TGraphNode;
  sn: TSymbolNode;
  oneSet: TCRTSet;
  undef, weak: boolean;
  pos: TPosition;
begin
  gL := 0;
  gR := 0;
  weak := False;
  case sym of
    identSym, stringSym, WEAKSym: 
    begin
      if (sym = WEAKSym) then 
      begin
        PerformGet;
        weak := True;
      end;
      _Symbol(Name, kind);
      sp := CocoTable.FindSym(Name);
      undef := sp = Ord(cnNoSym);
      if undef then
        if kind = ident then
          sp := CocoTable.NewSym(cnNonterminalSymbol, Name, 0)
        else if CocoTable.genScanner then
        begin
          sp := CocoTable.NewSym(cnTerminalSymbol, Name, line);
          MatchLiteral(sp)
        end
        else
        begin
          SemError(106);
          sp := 0
        end;
      CocoTable.GetSym(sp, sn);
      if (sn.snType <> cnTerminalSymbol) and (sn.snType <> cnNonterminalSymbol) then
        SemError(104);
      if weak then
        if sn.snType = cnTerminalSymbol then sn.snType := cnWeakTerminalSymbol
        else
          SemError(123);
      gL := CocoTable.NewNode(sn.snType, sp, line);
      gR := gL;
      if (sym = _lessSym) or
        (sym = _less_pointSym) then 
      begin
        _Attribs(pos);
        CocoTable.GetNode(gL, gn);
        gn.pos := pos;
        CocoTable.PutNode(gL, gn);
        CocoTable.GetSym(sp, sn);
        if sn.snType <> cnNonterminalSymbol then SemError(103);
        if undef then
        begin
          sn.attrPos := pos;
          CocoTable.PutSym(sp, sn)
        end
        else if sn.attrPos.beg < 0 then SemError(105);
      end 
      else if _In(symSet[1], sym) then 
      begin
        CocoTable.GetSym(sp, sn);
        if sn.attrPos.beg >= 0 then SemError(105);
      end 
      else 
      begin 
        SynError(60);
      end;
    end;
    _lparenSym: 
    begin
      PerformGet;
      _Expression(gL, gR);
      Expect(_rparenSym);
    end;
    _lbrackSym: 
    begin
      PerformGet;
      _Expression(gL, gR);
      Expect(_rbrackSym);
      CocoTable.MakeOption(gL, gR);
    end;
    _lbraceSym: 
    begin
      PerformGet;
      _Expression(gL, gR);
      Expect(_rbraceSym);
      CocoTable.MakeIteration(gL, gR);
    end;
    _lparen_pointSym: 
    begin
      _SemText(pos);
      gL := CocoTable.NewNode(cnSemanticAction, 0, 0);
      gR := gL;
      CocoTable.GetNode(gL, gn);
      gn.pos := pos;
      CocoTable.PutNode(gL, gn);
    end;
    ANYSym: 
    begin
      PerformGet;
      Fill(oneSet);
      Excl(oneSet, Ord(cnEndOfFile));
      gL := CocoTable.NewNode(cnSymbolANY, CocoTable.NewSet(oneSet), 0);
      gR := gL;
    end;
    SYNCSym: 
    begin
      PerformGet;
      gL := CocoTable.NewNode(cnSymbolSYNC, 0, 0);
      gR := gL;
    end;
    else 
    begin 
      SynError(61);
    end;
  end;
end;

procedure TpbCocoParser._Term(var gL, gR: Integer);
var
  gL2, gR2: integer;
begin
  gL := 0;
  gR := 0;
  if _In(symSet[2], sym) then 
  begin
    _Factor(gL, gR);
    while _In(symSet[2], sym) do 
    begin
      _Factor(gL2, gR2);
      CocoTable.ConcatSeq(gL, gR, gL2, gR2);
    end;
  end 
  else if (sym = _pointSym) or
    (sym = _rparenSym) or
    (sym = _barSym) or
    (sym = _rbrackSym) or
    (sym = _rbraceSym) then 
  begin
    gL := CocoTable.NewNode(cnEmptyAlternative, 0, 0);
    gR := gL;
  end 
  else 
  begin 
    SynError(62);
  end;
end;

procedure TpbCocoParser._Symbol(var Name: TsName; var kind: Integer);
var
  myName: string;
begin
  if (sym = identSym) then 
  begin
    _Ident(Name);
    kind := ident;
  end 
  else if (sym = stringSym) then 
  begin
    PerformGet;
    GetName(pos, len, myName);
    kind := stringSym;
    FixString(myName, len);
    Name := myName;
  end 
  else 
  begin 
    SynError(63);
  end;
end;

procedure TpbCocoParser._SingleChar(var n: Integer);
var
  i: integer;
  s: string;
begin
  Expect(CHRSym);
  Expect(_lparenSym);
  if (sym = numberSym) then 
  begin
    PerformGet;
    GetName(pos, len, s);
    Val(s, n, i);
    if n > 255 then 
    begin
      SemError(118);
      n := n mod 256 
    end;
    if CocoTable.ignoreCase then n := Ord(UpCase(CHR(n)));
  end 
  else if (sym = stringSym) then 
  begin
    PerformGet;
    GetName(pos, len, s);
    if len <> 3 then SemError(118);
    if CocoTable.ignoreCase then s[2] := UpCase(s[2]);
    n := Ord(s[2]);
  end 
  else 
  begin 
    SynError(64);
  end;
  Expect(_rparenSym);
end;

procedure TpbCocoParser._SimSet(var oneSet: TCRTSet);
var
  i, n1, n2: integer;
  c: integer;
  Name: TsName;
  s: string;
begin
  if (sym = identSym) then 
  begin
    _Ident(Name);
    c := CocoTable.ClassWithName(Name);
    if c < 0 then 
    begin
      SemError(115);
      Clear(oneSet) 
    end
    else
      CocoTable.GetClass(c, oneSet);
  end 
  else if (sym = stringSym) then 
  begin
    PerformGet;
    GetName(pos, len, s);
    Clear(oneSet);
    i := 2;
    while s[i] <> s[1] do 
    begin
      if CocoTable.ignoreCase then s[i] := UpCase(s[i]);
      Incl(oneSet, Ord(s[i]));
      INC(i)
    end;
  end 
  else if (sym = CHRSym) then 
  begin
    _SingleChar(n1);
    Clear(oneSet);
    Incl(oneSet, n1);
    if (sym = _point_pointSym) then 
    begin
      PerformGet;
      _SingleChar(n2);
      for i := n1 to n2 do Incl(oneSet, i);
    end;
  end 
  else if (sym = ANYSym) then 
  begin
    PerformGet;
    Fill(oneSet);
  end 
  else 
  begin 
    SynError(65);
  end;
end;

procedure TpbCocoParser._Set(var oneSet: TCRTSet);
var
  set2: TCRTSet;
begin
  _SimSet(oneSet);
  while (sym = _plusSym) or
    (sym = _minusSym) do 
  begin
    if (sym = _plusSym) then 
    begin
      PerformGet;
      _SimSet(set2);
      Unite(oneSet, set2);
    end 
    else 
    begin
      PerformGet;
      _SimSet(set2);
      Differ(oneSet, set2);
    end;
  end;
end;

procedure TpbCocoParser._TokenExpr(var gL, gR: Integer);
var
  gL2, gR2: integer;
  First: boolean;
begin
  _TokenTerm(gL, gR);
  First := True;
  while (sym = _barSym) do 
  begin
    PerformGet;
    _TokenTerm(gL2, gR2);
    if First then 
    begin
      CocoTable.MakeFirstAlt(gL, gR);
      First := False;
    end;
    CocoTable.ConcatAlt(gL, gR, gL2, gR2);
  end;
end;

procedure TpbCocoParser._NameDecl;
var
  Name: TsName;
  str: string;
begin
  _Ident(Name);
  Expect(_equalSym);
  if (sym = identSym) then 
  begin
    PerformGet;
    GetName(pos, len, str);
  end 
  else if (sym = stringSym) then 
  begin
    PerformGet;
    GetName(pos, len, str);
    FixString(str, len);
  end 
  else 
  begin 
    SynError(66);
  end;
  CocoTable.NewName(Name, str);
  Expect(_pointSym);
end;

procedure TpbCocoParser._TokenDecl(typ: TCocoNodeType);
var
  kind: integer;
  Name: TsName;
  pos: TPosition;
  sp, gL, gR: integer;
  sn: TSymbolNode;
begin
  _Symbol(Name, kind);
  sp := 0;
  // pc
  if CocoTable.FindSym(Name) <> Ord(cnNoSym) then SemError(107)
  else
  begin
    sp := CocoTable.NewSym(typ, Name, line);
    CocoTable.GetSym(sp, sn);
    sn.struct := classToken;
    CocoTable.PutSym(sp, sn);
  end;
  while not (_In(symSet[3], sym)) do 
  begin 
    SynError(67); 
    PerformGet; 
  end;
  if (sym = _equalSym) then 
  begin
    PerformGet;
    _TokenExpr(gL, gR);
    if kind <> ident then SemError(113);
    CocoTable.CompleteGraph(gR);
    CocoAutomaton.ConvertToStates(gL, sp);
    Expect(_pointSym);
  end 
  else if _In(symSet[4], sym) then 
  begin
    if kind = ident then CocoTable.genScanner := False
    else
      MatchLiteral(sp);
  end 
  else 
  begin 
    SynError(68);
  end;
  if (sym = _lparen_pointSym) then 
  begin
    _SemText(pos);
    if typ = cnTerminalSymbol then SemError(114);
    CocoTable.GetSym(sp, sn);
    sn.semPos := pos;
    CocoTable.PutSym(sp, sn);
  end;
end;

procedure TpbCocoParser._SetDecl;
var
  c: integer;
  oneSet: TCRTSet;
  Name: TsName;
begin
  _Ident(Name);
  c := CocoTable.ClassWithName(Name);
  if c >= 0 then SemError(107);
  Expect(_equalSym);
  _Set(oneSet);
  CocoTable.NewClass(Name, oneSet);
  Expect(_pointSym);
end;

procedure TpbCocoParser._Expression(var gL, gR: Integer);
var
  gL2, gR2: integer;
  First: boolean;
begin
  _Term(gL, gR);
  First := True;
  while (sym = _barSym) do 
  begin
    PerformGet;
    _Term(gL2, gR2);
    if First then 
    begin
      CocoTable.MakeFirstAlt(gL, gR);
      First := False;
    end;
    CocoTable.ConcatAlt(gL, gR, gL2, gR2);
  end;
end;

procedure TpbCocoParser._SemText(var semPos: TPosition);
begin
  Expect(_lparen_pointSym);
  semPos.beg := pos + 2;
  semPos.col := col + 2;
  while _In(symSet[5], sym) do 
  begin
    if _In(symSet[6], sym) then 
    begin
      PerformGet;
    end 
    else if (sym = badstringSym) then 
    begin
      PerformGet;
      SemError(102);
    end 
    else 
    begin
      PerformGet;
      SemError(109);
    end;
  end;
  Expect(_point_rparenSym);
  semPos.len := (pos - semPos.beg);
end;

procedure TpbCocoParser._Attribs(var attrPos: TPosition);
begin
  if (sym = _lessSym) then 
  begin
    PerformGet;
    attrPos.beg := pos + 1;
    attrPos.col := col + 1;
    while _In(symSet[7], sym) do 
    begin
      if _In(symSet[8], sym) then 
      begin
        PerformGet;
      end 
      else 
      begin
        PerformGet;
        SemError(102)
      end;
    end;
    Expect(_greaterSym);
    attrPos.len := (pos - attrPos.beg);
  end 
  else if (sym = _less_pointSym) then 
  begin
    PerformGet;
    attrPos.beg := pos + 2;
    attrPos.col := col + 2;
    while _In(symSet[9], sym) do 
    begin
      if _In(symSet[10], sym) then 
      begin
        PerformGet;
      end 
      else 
      begin
        PerformGet;
        SemError(102);
      end;
    end;
    Expect(_point_greaterSym);
    attrPos.len := (pos - attrPos.beg);
  end 
  else 
  begin 
    SynError(69);
  end;
end;

procedure TpbCocoParser._Declaration(var startedDFA: boolean);
var
  gL1, gR1, gL2, gR2: integer;
  nested: boolean;
begin
  nested := False;
  case sym of
    CHARACTERSSym: 
    begin
      PerformGet;
      while (sym = identSym) do 
      begin
        _SetDecl;
      end;
    end;
    TOKENSSym: 
    begin
      PerformGet;
      while (sym = identSym) or
        (sym = stringSym) do 
      begin
        _TokenDecl(cnTerminalSymbol);
      end;
    end;
    NAMESSym: 
    begin
      PerformGet;
      while (sym = identSym) do 
      begin
        _NameDecl;
      end;
    end;
    PRAGMASSym: 
    begin
      PerformGet;
      while (sym = identSym) or
        (sym = stringSym) do 
      begin
        _TokenDecl(cnPragma);
      end;
    end;
    COMMENTSSym: 
    begin
      PerformGet;
      Expect(FROMSym);
      _TokenExpr(gL1, gR1);
      Expect(TOSym);
      _TokenExpr(gL2, gR2);
      if (sym = NESTEDSym) then 
      begin
        PerformGet;
        nested := True;
      end 
      else if _In(symSet[11], sym) then 
      begin
        nested := False;
      end 
      else 
      begin 
        SynError(70);
      end;
      CocoAutomaton.NewComment(gL1, gL2, nested);
    end;
    IGNORESym: 
    begin
      PerformGet;
      if (sym = CASESym) then 
      begin
        PerformGet;
        if startedDFA then SemError(130);
        CocoTable.ignoreCase := True;
      end 
      else if (sym = identSym) or
        (sym = stringSym) or
        (sym = ANYSym) or
        (sym = CHRSym) then 
      begin
        _Set(CocoTable.ignored);
        if IsIn(CocoTable.ignored, 0) then SemError(119);
      end 
      else 
      begin 
        SynError(71);
      end;
    end;
    else 
    begin 
      SynError(72);
    end;
  end;
  startedDFA := True;
end;

procedure TpbCocoParser._ClassSection;
begin
  if _In(symSet[12], sym) then 
  begin
    case sym of
      GLOBALSym: 
      begin
        PerformGet;
        Cocotable.globalDeclPos.beg := nextPos;
        Cocotable.hasGlobalDecs := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.globalDeclPos.len := nextPos - CocoTable.globalDeclPos.beg;
        CocoTable.globalDeclPos.col := 0
      end;
      PRIVATESym: 
      begin
        PerformGet;
        Cocotable.privateDeclPos.beg := nextPos;
        Cocotable.hasprivateDecs := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.privateDeclPos.len := nextPos - CocoTable.privateDeclPos.beg;
        CocoTable.privateDeclPos.col := 0;
      end;
      PROTECTEDSym: 
      begin
        PerformGet;
        Cocotable.protectedDeclPos.beg := nextPos;
        Cocotable.hasprotectedDecs := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.protectedDeclPos.len := nextPos - CocoTable.protectedDeclPos.beg;
        CocoTable.protectedDeclPos.col := 0;
      end;
      PUBLICSym: 
      begin
        PerformGet;
        Cocotable.publicDeclPos.beg := nextPos;
        Cocotable.haspublicDecs := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.publicDeclPos.len := nextPos - CocoTable.publicDeclPos.beg;
        CocoTable.publicDeclPos.col := 0;
      end;
      PUBLISHEDSym: 
      begin
        PerformGet;
        Cocotable.publishedDeclPos.beg := nextPos;
        Cocotable.haspublishedDecs := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.publishedDeclPos.len := nextPos - CocoTable.publishedDeclPos.beg;
        CocoTable.publishedDeclPos.col := 0
      end;
      CREATESym: 
      begin
        PerformGet;
        Cocotable.createDeclPos.beg := nextPos;
        Cocotable.hascreateDecs := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.createDeclPos.len := nextPos - CocoTable.createDeclPos.beg;
        CocoTable.createDeclPos.col := 0;
      end;
      DESTROYSym: 
      begin
        PerformGet;
        Cocotable.destroyDeclPos.beg := nextPos;
        Cocotable.hasdestroyDecs := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.destroyDeclPos.len := nextPos - CocoTable.destroyDeclPos.beg;
        CocoTable.destroyDeclPos.col := 0;
      end;
      COMPILERFRAMESym: 
      begin
        PerformGet;
        Cocotable.CompilerFramePos.beg := nextPos;
        Cocotable.hasCompilerFrame := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.CompilerFramePos.len := nextPos - CocoTable.CompilerFramePos.beg;
        CocoTable.CompilerFramePos.col := 0;
        CocoTable.CompilerFrame := Copy(Src.DataString,
          Cocotable.CompilerFramePos.beg, CocoTable.CompilerFramePos.len);
      end;
      PARSERFRAMESym: 
      begin
        PerformGet;
        Cocotable.ParserFramePos.beg := nextPos;
        Cocotable.hasParserFrame := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.ParserFramePos.len := nextPos - CocoTable.ParserFramePos.beg;
        CocoTable.ParserFramePos.col := 0;
        CocoTable.ParserFrame := Copy(Src.DataString, Cocotable.ParserFramePos.beg,
          CocoTable.ParserFramePos.len);
      end;
      SCANNERFRAMESym: 
      begin
        PerformGet;
        Cocotable.ScannerFramePos.beg := nextPos;
        Cocotable.hasScannerFrame := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.ScannerFramePos.len := nextPos - CocoTable.ScannerFramePos.beg;
        CocoTable.ScannerFramePos.col := 0;
        CocoTable.ScannerFrame := Copy(Src.DataString,
          Cocotable.ScannerFramePos.beg, CocoTable.ScannerFramePos.len);
      end;
      TARGETDIRECTORYSym: 
      begin
        PerformGet;
        Cocotable.TARGETDIRECTORYPos.beg := nextPos;
        Cocotable.hasTARGETDIRECTORY := True;
        while _In(symSet[13], sym) do 
        begin
          PerformGet;
        end;
        CocoTable.TARGETDIRECTORYPos.len := nextPos - CocoTable.TARGETDIRECTORYPos.beg;
        CocoTable.TARGETDIRECTORYPos.col := 0;
        CocoTable.TargetDirectory := Copy(Src.DataString,
          Cocotable.TARGETDIRECTORYPos.beg, CocoTable.TARGETDIRECTORYPos.len);
      end;
    end;
  end 
  else if (sym = ERRORSSym) then 
  begin
    PerformGet;
    Cocotable.ErrorsPos.beg := nextPos;
    Cocotable.hasErrorsSource := True;
    while _In(symSet[13], sym) do 
    begin
      PerformGet;
    end;
    CocoTable.ErrorsPos.len := nextPos - CocoTable.ErrorsPos.beg;
    CocoTable.ErrorsPos.col := 0;
    CocoTable.ErrorsSource := Copy(Src.DataString,
      Cocotable.ErrorsPos.beg, CocoTable.ErrorsPos.len);
  end 
  else 
  begin 
    SynError(73);
  end;
end;

procedure TpbCocoParser._Ident(var Name: TsName);
var
  str: string;
begin
  Expect(identSym);
  GetName(pos, len, str);
  Name := str;
end;

procedure TpbCocoParser._pbCoco;
var
  startedDFA, ok, undef, hasAttrs: boolean;
  gR: integer;
  gramLine, sp: integer;
  Name, gramName: TsName;
  sn: TSymbolNode;
begin
  Expect(COMPILERSym);
  gramLine := line;
  CocoTable.NewSym(cnTerminalSymbol, 'EOF', 0);
  CocoTable.genScanner := True;
  CocoTable.ignoreCase := False;
  Clear(CocoTable.ignored);
  startedDFA := False;
  fHasOptions := True;
  _Ident(gramName);
  if (sym = USESSym) then 
  begin
    PerformGet;
    CocoTable.useDeclPos.beg := nextPos;
    CocoTable.hasUses := True;
    Expect(identSym);
    while (sym = _commaSym) do 
    begin
      PerformGet;
      Expect(identSym);
    end;
    CocoTable.useDeclPos.len := nextPos - CocoTable.useDeclPos.beg;
    CocoTable.useDeclPos.col := 0;
    Expect(_semicolonSym);
  end;
  CocoTable.semDeclPos.beg := nextPos;
  if (sym = DELPHISym) then 
  begin
    PerformGet;
    while _In(symSet[14], sym) do 
    begin
      _ClassSection;
    end;
    Expect(END_underscoreDELPHISym);
    CocoTable.semDeclPos.beg := nextPos;
  end;
  while _In(symSet[15], sym) do 
  begin
    PerformGet;
  end;
  CocoTable.semDeclPos.len := nextPos - CocoTable.semDeclPos.beg;
  CocoTable.semDeclPos.col := 0;
  while _In(symSet[16], sym) do 
  begin
    _Declaration(startedDFA);
  end;
  while not ((sym = EOFSYMB) or
    (sym = PRODUCTIONSSym)) do 
  begin 
    SynError(74); 
    PerformGet; 
  end;
  Expect(PRODUCTIONSSym);
  ok := Successful;
  if ok and CocoTable.genScanner then CocoAutomaton.MakeDeterministic(ok);
  if not ok then SemError(127);
  CocoTable.nNodes := 0;
  while (sym = identSym) do 
  begin
    _Ident(Name);
    sp := CocoTable.FindSym(Name);
    undef := sp = Ord(cnNoSym);
    if undef then 
    begin
      sp := CocoTable.NewSym(cnNonterminalSymbol, Name, line);
      CocoTable.GetSym(sp, sn)
    end
    else
    begin
      CocoTable.GetSym(sp, sn);
      if sn.snType = cnNonterminalSymbol then
      begin
        if sn.struct > 0 then SemError(107) 
      end
      else
        SemError(108);
      sn.line := line
    end;
    hasAttrs := sn.attrPos.beg >= 0;
    if (sym = _lessSym) or
      (sym = _less_pointSym) then 
    begin
      _Attribs(sn.attrPos);
      if not undef and not hasAttrs then SemError(105);
      CocoTable.PutSym(sp, sn);
    end 
    else if (sym = _equalSym) or
      (sym = _lparen_pointSym) then 
    begin
      if not undef and hasAttrs then SemError(105);
    end 
    else 
    begin 
      SynError(75);
    end;
    if (sym = _lparen_pointSym) then 
    begin
      _SemText(sn.semPos);
    end;
    ExpectWeak(_equalSym, 17);
    _Expression(sn.struct, gR);
    CocoTable.CompleteGraph(gR);
    CocoTable.PutSym(sp, sn);
    ExpectWeak(_pointSym, 18);
  end;
  Expect(ENDSym);
  _Ident(Name);
  sp := CocoTable.FindSym(gramName);
  if sp = Ord(cnNoSym) then SemError(111)
  else
  begin
    CocoTable.GetSym(sp, sn);
    if sn.attrPos.beg >= 0 then SemError(112);
    CocoTable.root := CocoTable.NewNode(cnNonterminalSymbol, sp, gramLine);
  end;
  if Name <> gramName then SemError(117);
  Expect(_pointSym);
  CocoTable.NewSym(cnTerminalSymbol, 'not', 0);
end;



procedure TpbCocoParser.Parse;
begin
  if (src.DataString = '') then 
    lst.WriteString('Empty Source')
  else 
  begin    
    _Reset; 
    PerformGet;
    _pbCoco;
  end;
end;

destructor TpbCocoParser.Destroy;
begin
  {PBDESTROY}
  
  {ENDPBDESTROY}
  inherited;
end;

constructor TpbCocoParser.Create;
begin
  inherited;
  {PBCREATE}
  
  {ENDPBCREATE}
  errDist := minErrDist;
  symSet[0, 0] := [EOFSYMB, identSym, stringSym, PRODUCTIONSSym, _equalSym, 
    CHARACTERSSym];
  symSet[0, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    IGNORESym - 16];
  symSet[0, 2] := [];
  symSet[0, 3] := [_lparen_pointSym - 48];
  symSet[1, 0] := [identSym, stringSym, _pointSym];
  symSet[1, 1] := [];
  symSet[1, 2] := [ANYSym - 32, _lparenSym - 32, _rparenSym - 32, _barSym - 32, 
    WEAKSym - 32, _lbrackSym - 32, _rbrackSym - 32];
  symSet[1, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, 
    _lparen_pointSym - 48];
  symSet[2, 0] := [identSym, stringSym];
  symSet[2, 1] := [];
  symSet[2, 2] := [ANYSym - 32, _lparenSym - 32, WEAKSym - 32, _lbrackSym - 32];
  symSet[2, 3] := [_lbraceSym - 48, SYNCSym - 48, _lparen_pointSym - 48];
  symSet[3, 0] := [EOFSYMB, identSym, stringSym, PRODUCTIONSSym, _equalSym, 
    CHARACTERSSym];
  symSet[3, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    IGNORESym - 16];
  symSet[3, 2] := [];
  symSet[3, 3] := [_lparen_pointSym - 48];
  symSet[4, 0] := [identSym, stringSym, PRODUCTIONSSym, CHARACTERSSym];
  symSet[4, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    IGNORESym - 16];
  symSet[4, 2] := [];
  symSet[4, 3] := [_lparen_pointSym - 48];
  symSet[5, 0] := [identSym, stringSym, badstringSym, numberSym, 
    COMPILERSym, USESSym, _commaSym, _semicolonSym, 
    DELPHISym, END_underscoreDELPHISym, PRODUCTIONSSym, 
    _equalSym, _pointSym, ENDSym, CHARACTERSSym];
  symSet[5, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    FROMSym - 16, TOSym - 16, NESTEDSym - 16, IGNORESym - 16, 
    CASESym - 16, GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, 
    PUBLICSym - 16, PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[5, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32, ERRORSSym - 32, _plusSym - 32, 
    _minusSym - 32, _point_pointSym - 32, ANYSym - 32, CHRSym - 32, 
    _lparenSym - 32, _rparenSym - 32, _barSym - 32, WEAKSym - 32, 
    _lbrackSym - 32, _rbrackSym - 32];
  symSet[5, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, CONTEXTSym - 48, 
    _lessSym - 48, _greaterSym - 48, _less_pointSym - 48, 
    _point_greaterSym - 48, _lparen_pointSym - 48, NO_SYMB - 48];
  symSet[6, 0] := [identSym, stringSym, numberSym, COMPILERSym, USESSym, 
    _commaSym, _semicolonSym, DELPHISym, 
    END_underscoreDELPHISym, PRODUCTIONSSym, _equalSym, 
    _pointSym, ENDSym, CHARACTERSSym];
  symSet[6, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    FROMSym - 16, TOSym - 16, NESTEDSym - 16, IGNORESym - 16, 
    CASESym - 16, GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, 
    PUBLICSym - 16, PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[6, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32, ERRORSSym - 32, _plusSym - 32, 
    _minusSym - 32, _point_pointSym - 32, ANYSym - 32, CHRSym - 32, 
    _lparenSym - 32, _rparenSym - 32, _barSym - 32, WEAKSym - 32, 
    _lbrackSym - 32, _rbrackSym - 32];
  symSet[6, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, CONTEXTSym - 48, 
    _lessSym - 48, _greaterSym - 48, _less_pointSym - 48, 
    _point_greaterSym - 48, NO_SYMB - 48];
  symSet[7, 0] := [identSym, stringSym, badstringSym, numberSym, 
    COMPILERSym, USESSym, _commaSym, _semicolonSym, 
    DELPHISym, END_underscoreDELPHISym, PRODUCTIONSSym, 
    _equalSym, _pointSym, ENDSym, CHARACTERSSym];
  symSet[7, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    FROMSym - 16, TOSym - 16, NESTEDSym - 16, IGNORESym - 16, 
    CASESym - 16, GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, 
    PUBLICSym - 16, PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[7, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32, ERRORSSym - 32, _plusSym - 32, 
    _minusSym - 32, _point_pointSym - 32, ANYSym - 32, CHRSym - 32, 
    _lparenSym - 32, _rparenSym - 32, _barSym - 32, WEAKSym - 32, 
    _lbrackSym - 32, _rbrackSym - 32];
  symSet[7, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, CONTEXTSym - 48, 
    _lessSym - 48, _less_pointSym - 48, _point_greaterSym - 48, 
    _lparen_pointSym - 48, _point_rparenSym - 48, NO_SYMB - 48];
  symSet[8, 0] := [identSym, stringSym, numberSym, COMPILERSym, USESSym, 
    _commaSym, _semicolonSym, DELPHISym, 
    END_underscoreDELPHISym, PRODUCTIONSSym, _equalSym, 
    _pointSym, ENDSym, CHARACTERSSym];
  symSet[8, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    FROMSym - 16, TOSym - 16, NESTEDSym - 16, IGNORESym - 16, 
    CASESym - 16, GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, 
    PUBLICSym - 16, PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[8, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32, ERRORSSym - 32, _plusSym - 32, 
    _minusSym - 32, _point_pointSym - 32, ANYSym - 32, CHRSym - 32, 
    _lparenSym - 32, _rparenSym - 32, _barSym - 32, WEAKSym - 32, 
    _lbrackSym - 32, _rbrackSym - 32];
  symSet[8, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, CONTEXTSym - 48, 
    _lessSym - 48, _less_pointSym - 48, _point_greaterSym - 48, 
    _lparen_pointSym - 48, _point_rparenSym - 48, NO_SYMB - 48];
  symSet[9, 0] := [identSym, stringSym, badstringSym, numberSym, 
    COMPILERSym, USESSym, _commaSym, _semicolonSym, 
    DELPHISym, END_underscoreDELPHISym, PRODUCTIONSSym, 
    _equalSym, _pointSym, ENDSym, CHARACTERSSym];
  symSet[9, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    FROMSym - 16, TOSym - 16, NESTEDSym - 16, IGNORESym - 16, 
    CASESym - 16, GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, 
    PUBLICSym - 16, PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[9, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32, ERRORSSym - 32, _plusSym - 32, 
    _minusSym - 32, _point_pointSym - 32, ANYSym - 32, CHRSym - 32, 
    _lparenSym - 32, _rparenSym - 32, _barSym - 32, WEAKSym - 32, 
    _lbrackSym - 32, _rbrackSym - 32];
  symSet[9, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, CONTEXTSym - 48, 
    _lessSym - 48, _greaterSym - 48, _less_pointSym - 48, 
    _lparen_pointSym - 48, _point_rparenSym - 48, NO_SYMB - 48];
  symSet[10, 0] := [identSym, stringSym, numberSym, COMPILERSym, USESSym, 
    _commaSym, _semicolonSym, DELPHISym, 
    END_underscoreDELPHISym, PRODUCTIONSSym, _equalSym, 
    _pointSym, ENDSym, CHARACTERSSym];
  symSet[10, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    FROMSym - 16, TOSym - 16, NESTEDSym - 16, IGNORESym - 16, 
    CASESym - 16, GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, 
    PUBLICSym - 16, PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[10, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32, ERRORSSym - 32, _plusSym - 32, 
    _minusSym - 32, _point_pointSym - 32, ANYSym - 32, CHRSym - 32, 
    _lparenSym - 32, _rparenSym - 32, _barSym - 32, WEAKSym - 32, 
    _lbrackSym - 32, _rbrackSym - 32];
  symSet[10, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, CONTEXTSym - 48, 
    _lessSym - 48, _greaterSym - 48, _less_pointSym - 48, 
    _lparen_pointSym - 48, _point_rparenSym - 48, NO_SYMB - 48];
  symSet[11, 0] := [PRODUCTIONSSym, CHARACTERSSym];
  symSet[11, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    IGNORESym - 16];
  symSet[11, 2] := [];
  symSet[11, 3] := [];
  symSet[12, 0] := [];
  symSet[12, 1] := [GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, PUBLICSym - 16, 
    PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[12, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32];
  symSet[12, 3] := [];
  symSet[13, 0] := [identSym, stringSym, badstringSym, numberSym, 
    COMPILERSym, USESSym, _commaSym, _semicolonSym, 
    DELPHISym, PRODUCTIONSSym, _equalSym, _pointSym, ENDSym, 
    CHARACTERSSym];
  symSet[13, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    FROMSym - 16, TOSym - 16, NESTEDSym - 16, IGNORESym - 16, 
    CASESym - 16];
  symSet[13, 2] := [_plusSym - 32, _minusSym - 32, _point_pointSym - 32, ANYSym - 32, 
    CHRSym - 32, _lparenSym - 32, _rparenSym - 32, _barSym - 32, 
    WEAKSym - 32, _lbrackSym - 32, _rbrackSym - 32];
  symSet[13, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, CONTEXTSym - 48, 
    _lessSym - 48, _greaterSym - 48, _less_pointSym - 48, 
    _point_greaterSym - 48, _lparen_pointSym - 48, 
    _point_rparenSym - 48, NO_SYMB - 48];
  symSet[14, 0] := [];
  symSet[14, 1] := [GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, PUBLICSym - 16, 
    PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[14, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32, ERRORSSym - 32];
  symSet[14, 3] := [];
  symSet[15, 0] := [identSym, stringSym, badstringSym, numberSym, 
    COMPILERSym, USESSym, _commaSym, _semicolonSym, 
    DELPHISym, END_underscoreDELPHISym, _equalSym, _pointSym, 
    ENDSym];
  symSet[15, 1] := [FROMSym - 16, TOSym - 16, NESTEDSym - 16, CASESym - 16, 
    GLOBALSym - 16, PRIVATESym - 16, PROTECTEDSym - 16, PUBLICSym - 16, 
    PUBLISHEDSym - 16, CREATESym - 16, DESTROYSym - 16];
  symSet[15, 2] := [COMPILERFRAMESym - 32, PARSERFRAMESym - 32, SCANNERFRAMESym - 32, 
    TARGETDIRECTORYSym - 32, ERRORSSym - 32, _plusSym - 32, 
    _minusSym - 32, _point_pointSym - 32, ANYSym - 32, CHRSym - 32, 
    _lparenSym - 32, _rparenSym - 32, _barSym - 32, WEAKSym - 32, 
    _lbrackSym - 32, _rbrackSym - 32];
  symSet[15, 3] := [_lbraceSym - 48, _rbraceSym - 48, SYNCSym - 48, CONTEXTSym - 48, 
    _lessSym - 48, _greaterSym - 48, _less_pointSym - 48, 
    _point_greaterSym - 48, _lparen_pointSym - 48, 
    _point_rparenSym - 48, NO_SYMB - 48];
  symSet[16, 0] := [CHARACTERSSym];
  symSet[16, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    IGNORESym - 16];
  symSet[16, 2] := [];
  symSet[16, 3] := [];
  symSet[17, 0] := [EOFSYMB, identSym, stringSym, PRODUCTIONSSym, _equalSym, 
    _pointSym, CHARACTERSSym];
  symSet[17, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    IGNORESym - 16];
  symSet[17, 2] := [ANYSym - 32, _lparenSym - 32, _barSym - 32, WEAKSym - 32, 
    _lbrackSym - 32];
  symSet[17, 3] := [_lbraceSym - 48, SYNCSym - 48, _lparen_pointSym - 48];
  symSet[18, 0] := [EOFSYMB, identSym, stringSym, PRODUCTIONSSym, _equalSym, 
    ENDSym, CHARACTERSSym];
  symSet[18, 1] := [TOKENSSym - 16, NAMESSym - 16, PRAGMASSym - 16, COMMENTSSym - 16, 
    IGNORESym - 16];
  symSet[18, 2] := [];
  symSet[18, 3] := [_lparen_pointSym - 48];
end;


end.
