// Generated by ParserBuilder @ 2/05/2002 8:22:47 PM

unit pbSHLParser;

(* NOTE: Any changes made to this file may be overwritten when it gets regenerated
  from within ParserBuilder - unless you run the Delphi Import command*)


interface

uses
  Windows, Messages, SysUtils, Classes, pbStrLib, pbSHLScanner;


const
  maxT = 36;
  minErrDist = 2;  (* minimal distance (good tokens) between two errors *)
  setsize = 16;  (* sets are stored in 16 bits *)

type
  BITSET = set of 0..15;
  TSymbolSet = array [0..maxT div setsize] of BITSET;

  {PBGLOBAL}

  {ENDPBGLOBAL}


  { Fish }


type
  TpbSHLParser = class(TpbSHLScanner)
  private
    FSuccessful: boolean;
    {PBPRIVATE}
    fOutputStream: TMemoryStream;
    fCollectStart: Integer;
    fCollectLength: Integer;
    fEnableSHL,
    fInComment: boolean;
    FCurrentFontIdx: Integer;
    fSemFontIdx: Integer;
    procedure Init;
    procedure Final;
    function CalcLength: Integer;
    procedure SetStart;
    function CopySourceToCurrent: string;
    procedure WriteStr(S: string);

    {ENDPBPRIVATE}
    procedure PerformGet;
    procedure SynError(errNo: Integer);
    function _In(var s: TSymbolSet; x: Integer): boolean;
    procedure Expect(n: Integer);
    function WeakSeparator(n, syFol, repFol: Integer): boolean;
    function GetSuccessful: boolean;
    procedure SetSourceString(const Value: string);
    procedure _DeletedLineTag;
    procedure _AddedLineTag;
    procedure _DeletedLine;
    procedure _AddedLine;
    procedure _KEYWORD;
    procedure _KEEP;
    procedure _CONTENTCLASS;
    procedure _pbSHL;


  protected
    {PBPROTECTED}
     
    {ENDPBPROTECTED}
  public
    {PBPUBLIC}
    fFontSize: Integer;

    {ENDPBPUBLIC}
    constructor Create;
    destructor Destroy; override;
    procedure Parse;
    procedure LexString(var Lex: string);
    procedure LexName(var Lex: string);
    procedure LookAheadString(var Lex: string);
    procedure LookAheadName(var Lex: string);
  published
    property Successful: boolean read GetSuccessful;
    property SourceString: string write SetSourceString;
    {PBPUBLISHED}
    property SemFontIdx: Integer read FSemFontIdx write FSemFontIdx;

    {ENDPBPUBLISHED}
  end;

implementation

var
  symSet: array [0..2] of TSymbolSet;
  errDist: integer;
  sym: integer;

{  +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-
   + For ParserBuilder's Delphi import function to work,        -
   + you must place your code in this Arbitrary Source section. -
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+- }

  {PBARBITRARYSOURCE}


procedure TpbSHLParser.Init;
begin
  fOutputStream.Clear;
  lst.size := 0;
  fEnableSHL := True;
  fInComment := False;
  FCurrentFontIdx := 0;
end;

procedure TpbSHLParser.Final;
begin
  fOutputStream.Position := 0;
  fOutputStream.SaveToStream(lst);
  fOutputStream.Clear;
end;

procedure TpbSHLParser.WriteStr(S: string);
begin
  fOutputStream.WriteBuffer(S[1], length(S));
end;

function TpbSHLParser.CopySourceToCurrent: string;
begin
  CalcLength;
  Result := Copy(src.DataString, FCollectStart, fCollectLength);
end;

function TpbSHLParser.CalcLength: Integer;
begin
  Result := nextPos - fCollectStart + 1;
  fCollectLength := Result;
end;

procedure TpbSHLParser.SetStart;
begin
  fCollectStart := nextPos + 1;
end;

{ENDPBARBITRARYSOURCE}

 { TpbSHLParser - Generated Methods below}
procedure TpbSHLParser.SynError(errNo: Integer);
begin
  if errDist >= minErrDist then
  begin
    Error(errNo, nextLine, nextCol, nextPos);
  end;
  errDist := 0;
end;

procedure TpbSHLParser.PerformGet;
begin
  repeat
    Get(sym);
    if sym <= maxT then
      INC(errDist)
    else
    begin     
    end;
  until sym <= maxT
  end;

function TpbSHLParser._In(var s: TSymbolSet; x: Integer): boolean;
begin
  _In := x mod setsize in s[x div setsize];
end;

function TpbSHLParser.GetSuccessful: boolean;
begin
  FSuccessful := errors = 0;
  Result := FSuccessful;
end;

procedure TpbSHLParser.Expect(n: Integer);
begin
  if Sym = n then PerformGet
  else
    SynError(n);
end;

function TpbSHLParser.WeakSeparator(n, syFol, repFol: Integer): boolean;
var
  s: TSymbolSet;
  i: integer;
begin
  if sym = n then
  begin
    PerformGet;
    WeakSeparator := True;
    EXIT;
  end
  else if _In(symSet[repFol], sym) then
  begin
    WeakSeparator := False;
    exit
  end
  else
  begin
    i := 0;
    while i <= maxT div setsize do
    begin
      s[i] := symSet[0, i] + symSet[syFol, i] + symSet[repFol, i];
      INC(i)
    end;
    SynError(n);
    while not _In(s, sym) do PerformGet;
    WeakSeparator := _In(symSet[syFol], sym)
  end
end;

procedure TpbSHLParser.LexName(var Lex: string);
begin
  GetName(pos, len, Lex)
end;

procedure TpbSHLParser.LexString(var Lex: string);
begin
  GetString(pos, len, Lex)
end;

procedure TpbSHLParser.LookAheadName(var Lex: string);
begin
  GetName(nextPos, nextLen, Lex);
end;

procedure TpbSHLParser.LookAheadString(var Lex: string);
begin
  GetString(nextPos, nextLen, Lex)
end;

procedure TpbSHLParser.SetSourceString(const Value: string);
begin
  if (src <> nil) then
    src.Free;
  src := TStringStream.Create(Value);
end;

procedure TpbSHLParser._DeletedLineTag;
begin
  Expect(35);
end;

procedure TpbSHLParser._AddedLineTag;
begin
  Expect(34);
end;

procedure TpbSHLParser._DeletedLine;
begin
  SetStart;
  _DeletedLineTag;
  WriteStr('\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf1\b ' +
    CopySourceToCurrent + '\plain\f2\fs' + IntToStr(fFontSize * 2) + ' ');
  while (sym = 1) or (sym = 3) do 
  begin
    if (sym = 1) then 
    begin
      PerformGet;
    end 
    else 
    begin
      PerformGet;
    end;
  end;
  Expect(2);
end;

procedure TpbSHLParser._AddedLine;
begin
  SetStart;
  _AddedLineTag;
  while (sym = 1) or (sym = 3) do 
  begin
    if (sym = 1) then 
    begin
      PerformGet;
    end 
    else 
    begin
      PerformGet;
    end;
  end;
  Expect(2);
  WriteStr('\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf2\ul\b ' +
    CopySourceToCurrent + '\plain\f2\fs' + IntToStr(fFontSize * 2) + ' ');
end;

procedure TpbSHLParser._KEYWORD;
begin
  if _In(symSet[1], sym) then 
  begin
    SetStart;
    case sym of
      6: 
      begin
        PerformGet;
      end;
      7: 
      begin
        PerformGet;
      end;
      8: 
      begin
        PerformGet;
      end;
      9: 
      begin
        PerformGet;
      end;
      10: 
      begin
        PerformGet;
      end;
      11: 
      begin
        PerformGet;
      end;
      12: 
      begin
        PerformGet;
      end;
      13: 
      begin
        PerformGet;
      end;
      14: 
      begin
        PerformGet;
      end;
      15: 
      begin
        PerformGet;
      end;
      16: 
      begin
        PerformGet;
        fEnableSHL := True;
      end;
      17: 
      begin
        PerformGet;
      end;
      18: 
      begin
        PerformGet;
      end;
      19: 
      begin
        PerformGet;
      end;
      20: 
      begin
        PerformGet;
      end;
      21: 
      begin
        PerformGet;
      end;
      22: 
      begin
        PerformGet;
      end;
      23: 
      begin
        PerformGet;
      end;
      24: 
      begin
        PerformGet;
      end;
      25: 
      begin
        PerformGet;
      end;
      26: 
      begin
        PerformGet;
      end;
      27: 
      begin
        PerformGet;
      end;
      28: 
      begin
        PerformGet;
      end;
      29: 
      begin
        PerformGet;
      end;
      30: 
      begin
        PerformGet;
      end;
      31: 
      begin
        PerformGet;
      end;
    end;
    if (fEnableSHL and not fInComment) then
      WriteStr('\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf0\b ' +
        UpperCase(CopySourceToCurrent) + '\plain\f2\fs' + IntToStr(fFontSize * 2))
    else
      WriteStr('\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf0\b ' + CopySourceToCurrent);
  end 
  else if (sym = 32) or (sym = 33) then 
  begin
    if (sym = 32) then 
    begin
      PerformGet;
      fInComment := True;
      FCurrentFontIdx := fSemFontIdx;
      WriteStr('\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf' +
        IntToStr(fSemFontIdx) + ' (. ');
    end 
    else 
    begin
      PerformGet;
      fInComment := False;
      WriteStr('\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf' +
        IntToStr(fSemFontIdx) + ' .) ' + '\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf0');
      FCurrentFontIdx := 0;
    end;
  end 
  else 
  begin 
    SynError(37);
  end;
end;

procedure TpbSHLParser._KEEP;
begin
  SetStart;
  Expect(1);
  WriteStr(CopySourceToCurrent)
end;

procedure TpbSHLParser._CONTENTCLASS;
begin
  case sym of
    5: 
    begin
      SetStart;
      PerformGet;
      WriteStr('\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf' +
        IntToStr(FCurrentFontIdx) +
        '\ulwave ' + trim(CopySourceToCurrent) + '\plain\f2' + '\cf' +
        IntToStr(FCurrentFontIdx) +
        '\fs' + IntToStr(fFontSize * 2) + '  ');
    end;
    1: 
    begin
      if not fInComment then FCurrentFontIdx := 0;
      _KEEP;
    end;
    6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22,
    23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33: 
    begin
      _KEYWORD;
    end;
    34: 
    begin
      _AddedLine;
    end;
    35: 
    begin
      _DeletedLine;
    end;
    3: 
    begin
      SetStart;
      PerformGet;
      WriteStr('\plain\f2\fs' + IntToStr(fFontSize * 2) + '\cf' +
        IntToStr(FCurrentFontIdx) +
        CopySourceToCurrent);
    end;
    2: 
    begin
      PerformGet;
      WriteStr(#13#10);
    end;
    else 
    begin 
      SynError(38);
    end;
  end;
end;

procedure TpbSHLParser._pbSHL;
begin
  Init;
  _CONTENTCLASS;
  while _In(symSet[2], sym) do 
  begin
    _CONTENTCLASS;
  end;
  Final;
end;



procedure TpbSHLParser.Parse;
begin
  if (src.DataString = '') then 
    lst.WriteString('Empty Source')
  else 
  begin    
    _Reset; 
    PerformGet;
    _pbSHL;
  end;
end;

destructor TpbSHLParser.Destroy;
begin
  {PBDESTROY}
  fOutputStream.Free;

  {ENDPBDESTROY}
  inherited;
end;

constructor TpbSHLParser.Create;
begin
  inherited;
  {PBCREATE}
  fOutputStream := TMemoryStream.Create;
  // Error := ReportError;

  {ENDPBCREATE}
  errDist := minErrDist;
  symSet[0, 0] := [0];
  symSet[0, 1] := [];
  symSet[0, 2] := [];
  symSet[1, 0] := [6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[1, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[1, 2] := [];
  symSet[2, 0] := [1, 2, 3, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[2, 1] := [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15];
  symSet[2, 2] := [0, 1, 2, 3];
end;


end.
